//======================================================== IBJmsg.h
//
// Message Routines for IBJ-programs
// =================================
//
// Copyright (C) Dr. Lutz Janicke, Dunum, Germany, 1999-2000
// email: lj@janicke.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// history:
//
// last change: 98-07-31  lj
// 2000-07-27 uj  extended for IBJodor
//
//==================================================================

#ifndef  IBJMSG_INCLUDE
#define  IBJMSG_INCLUDE

#include <stdio.h>

#define  SYMOPT   "-"
#define  PATHSEP  '/'
#define  ALTPSEP  '\\'
#define  MAXFNLEN 256
#define  EOL      "\n"

#define  dP(a)   char *ePGMn = #a; char ePGMs[80]
#define  eG(a)   if(MsgCode<0) eX(a)
#define  eX(a)   {sprintf(ePGMs,"%s.%s.%s",eMODn,ePGMn,#a); MsgCode=-1; goto eX_ ## a;}
#define  eMSG    return MsgCode=-1, vMsg

#define ALLOC(a)        calloc(1,(a))
#define CALLOC(a,b)     calloc((a),(b))
#define FREE(a)         free(a)
#define REALLOC(a,b)    realloc((a),(b))

extern char *MsgVersion;
extern int MsgCode, MsgQuiet, MsgVerbose, MsgBufLen;
extern int MsgTranslate;
extern FILE *MsgFile;

void MsgLow(    /* convert to lower case        */
char *s )       /* string to be converted       */
  ;
char *MsgTok(   /* non-destructive tokenisation */
char *start,    /* begin of scanning            */
char **pnext,   /* start of next scan           */
char *sep,      /* separator characters         */
int *pl )       /* number of usable characters  */
  ;             /* RETURN: start of token       */

int vMsg(       /* print message on screen and into logfile     */
char *format,   /* printing format                              */
... )           /* parameter                                    */
  ;
double MsgDateVal(      /* converts date string into numerical value    */
char * ss )             /* string of the form yy-mm-dd'hh:mm:ss         */
  ;                     /* RETURN: days after 1899-12-30'00:00:00 +1.e6 */

char *MsgDateString(    /* converts date value into string      */
double d )              /* days after 1899-12-30'00:00:00 +1.e6 */
  ;                     /* RETURN: string yy-mm-dd'hh:mm:ss     */

double MsgDateSeconds(  /* converts time from t1 to t2 into seconds */
double t1,
double t2 )
  ;

#endif  /*##################################################################*/
